{$A+,B-,D+,E+,F-,G-,I-,L+,N+,O-,P-,Q+,R+,S+,T-,V+,X+,Y+}
{$M 65520,0,655360}

uses
  z3_15u; {flowUnit}

const
  mMax = 25;

var
  m, A, B, AtoB : integer;
  Net : array[1..Nmax, 1..NMax] of boolean;
  c : tC;
  flow : tFlow;

procedure Init;
var
  i, j : integer;
begin
  assign(input, 'input.txt');
  reSet(input);
  fillChar(Net, sizeOf(Net), false);
  AtoB := 0;

  read(m, A, B);
  while not seekEof do begin
    read(i, j);
    if i<>j then begin
      Net[i,j] := true;
      if (i = A) and (j = B) then
        inc(AtoB);
    end;
  end;
end;

procedure makeNet;
var
  i, j, K : integer;
begin
  fillChar(c, sizeOf(c), 0);
  for i := 1 to M do
    c[2*i-1, 2*i] := 1;

  for i := 1 to m do
    for j := 1 to m do
      if net[i, j] then
        c[2*i, 2*j-1] := 1;

  findFlow(flow, c, 2*A, 2*B-1, 2*M);
end;

procedure Print;
var
  i, j, k : integer;
begin
  assign(output, 'output.txt');
  reWrite(outPut);

  k := 0;
  for i := 1 to m do
    if flow[2*A, 2*i-1] = 1 then
      inc(k);

  if AtoB > 0 then
    inc(k, AtoB-1);

  writeLn(k);

  for i := 1 to m do
    if flow[2*A, 2*i-1] = 1 then begin
      write(A,' ');

      k := i;
      while k <> B do begin
        write(k,' ');

        j := 1;
        while flow[2*k, 2*j-1] = 0 do
          inc(j);

        k := j;
      end;

      writeLn(B, ' ');
    end;

  for i := 1 to AtoB-1 do
    writeln(A,' ',B);
end;

begin
  init;
  makeNet;
  Print;
end.
